#include "ros/ros.h"
#include "std_msgs/String.h"
#include <ros/callback_queue.h>

void slowPublisherCallback(const std_msgs::String::ConstPtr& msg)
{
	ROS_INFO("%s", msg->data.c_str());
}

void fastPublisherCallback(const std_msgs::String::ConstPtr& msg)
{
	ROS_INFO("%s", msg->data.c_str());
	sleep(5);
}

int main(int argc, char **argv)
{
	ros::init(argc, argv, "subscriber");

	ros::NodeHandle slowNodeHandle;
	ros::NodeHandle fastNodeHandle;

	ros::CallbackQueue slowQueue;
	ros::CallbackQueue fastQueue;

	slowNodeHandle.setCallbackQueue(&slowQueue);
	fastNodeHandle.setCallbackQueue(&fastQueue);

	ros::Subscriber slowSubscriber = slowNodeHandle.subscribe("slow_publisher", 1, slowPublisherCallback);
	ros::Subscriber fastSubscriber = fastNodeHandle.subscribe("fast_publisher", 4, fastPublisherCallback);

	ros::AsyncSpinner slowSpinner(1, &slowQueue);
	ros::AsyncSpinner fastSpinner(1, &fastQueue);

	slowSpinner.start();
	fastSpinner.start();

	while (true);

	return 0;
}